import 'package:car_app/service/interface/authentication.dart';
import 'package:car_app/view/authentication.dart';
import 'package:flutter/material.dart';
import 'package:permission_handler/permission_handler.dart';
import 'package:provider/provider.dart';

// This is also a dirty class, used to initialize some things and request permissions
// It is intended to be used as a startup class
class StartupView extends StatefulWidget {
  final String replacementViewRoute;

  const StartupView({super.key, required this.replacementViewRoute});

  @override
  State<StatefulWidget> createState() => _StartupViewState();
}

class _StartupViewState extends State<StartupView> {
  @override
  Widget build(BuildContext context) {
    onStartup().then((value) {
      Navigator.pushReplacementNamed(context, widget.replacementViewRoute);
    });

    return const Scaffold(
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Text("Initializing..."),
            SizedBox(height: 8),
            CircularProgressIndicator(),
          ],
        )
      ),
    );
  }

  Future<void> onStartup() async {
    var authenticationService = Provider.of<AuthenticationService>(context, listen: false);

    await Permission.locationWhenInUse.request();
    await Permission.ignoreBatteryOptimizations.request();
    await Permission.notification.request();

    var isLoggedIn = await authenticationService.isLoggedIn();
    if(!isLoggedIn && mounted) {
      await Navigator.push(context, MaterialPageRoute<bool>(builder: (context) => const AuthenticationView()));
    }
  }
}
