import 'package:car_app/exception/authentication.dart';
import 'package:car_app/service/interface/authentication.dart';
import 'package:flutter/material.dart';

class AuthenticationViewModel extends ChangeNotifier {
  final AuthenticationService authenticationService;

  AuthenticationViewModel({required this.authenticationService});

  void login(String username, String password, void Function() onLoggedIn, void Function(String) onError) {
    authenticationService.loginUsernamePassword(username, password)
      .then((_) => onLoggedIn())
      .onError<AuthenticationException>((error, _) => onError(error.message));
  }

  void register(String name, String username, String password, void Function() onRegistered, void Function(String) onError) {
    authenticationService.register(name, username, password)
      .then((_) => onRegistered())
      .onError<AuthenticationException>((error, _) => onError(error.message));
  }
}
